Index: applications/editors/josm/i18n/build.xml
===================================================================
--- applications/editors/josm/i18n/build.xml	(revision 30879)
+++ applications/editors/josm/i18n/build.xml	(revision 31029)
@@ -7,5 +7,5 @@
     <property name="plugin.dir" value="../plugins"/>
     <property name="validator.tagfile" value="${josm.build.dir}/data/validator/tagchecker.cfg"/>
-    <property name="wms.srcfile" value="http://josm.openstreetmap.de/maps"/>
+    <property name="maps.srcfile" value="http://josm.openstreetmap.de/maps"/>
     <property name="surveyor.srcfile" value="${plugin.dir}/surveyor/resources/surveyor.xml"/>
     <property name="i18n.build.dir" value="build"/>
@@ -34,6 +34,6 @@
             <arg line="convvalidator.pl ${validator.tagfile}"/>
         </exec>
-        <exec executable="perl" failonerror="true" output="${i18n.build.dir}/trans_wms.java">
-            <arg line="convwms.pl ${wms.srcfile}"/>
+        <exec executable="perl" failonerror="true" output="${i18n.build.dir}/trans_maps.java">
+            <arg line="convmaps.pl ${maps.srcfile}"/>
         </exec>
         <exec executable="perl" failonerror="true" output="${i18n.build.dir}/trans_surveyor.java">
Index: applications/editors/josm/i18n/convmaps.pl
===================================================================
--- applications/editors/josm/i18n/convmaps.pl	(revision 31029)
+++ applications/editors/josm/i18n/convmaps.pl	(revision 31029)
@@ -0,0 +1,63 @@
+#! /usr/bin/perl -w
+
+# Written by Dirk Stöcker <openstreetmap@dstoecker.de>
+# Public domain, no rights reserved.
+
+use strict;
+use LWP::Simple;
+use encoding 'utf8';
+
+my $item;
+my $comment = 0;
+
+# This is a simple conversion and in no way a complete XML parser
+# but it works with a default Perl installation
+
+# Print a header to write valid Java code.  No line break,
+# so that the input and output line numbers will match.
+print "class trans_maps { void tr(String s){} void f() {";
+
+my @lines;
+if($ARGV[0] && $ARGV[0] =~ /^http:\/\//)
+{
+  my $content = get($ARGV[0]);
+  die "Couldn't get $ARGV[0]" unless defined $content;
+  @lines = split("\r?\n", $content);
+}
+else
+{
+  @lines = <>;
+}
+
+for my $line (@lines)
+{
+  $line =~ s/\r//g;
+  chomp($line);
+  print "tr(\"\"); ";
+  if($line =~ /<name>(.*)<\/name>/)
+  {
+    my $val = $1;
+    $val =~ s/&amp;/&/g;
+    print "tr(\"$val\"); /* $line */\n";
+  }
+  if($line =~ /<description +lang=['"]en['"]>(.*)<\/description>/)
+  {
+    my $val = $1;
+    $val =~ s/&amp;/&/g;
+    print "tr(\"$val\"); /* $line */\n";
+  }
+  elsif($line =~ /^[ \t]*$/)
+  {
+    print "\n";
+  }
+  elsif($line =~ /<entry>/) # required or the gettext info texts get too large
+  {
+    print "public newEntry() {};\n";
+  }
+  else
+  {
+    print "/* $line */\n";
+  }
+}
+
+print "}}\n";
Index: applications/editors/josm/i18n/convwms.pl
===================================================================
--- applications/editors/josm/i18n/convwms.pl	(revision 30879)
+++ 	(revision )
@@ -1,57 +1,0 @@
-#! /usr/bin/perl -w
-
-# Written by Dirk Stöcker <openstreetmap@dstoecker.de>
-# Public domain, no rights reserved.
-
-use strict;
-use LWP::Simple;
-use encoding 'utf8';
-
-my $item;
-my $comment = 0;
-
-# This is a simple conversion and in no way a complete XML parser
-# but it works with a default Perl installation
-
-# Print a header to write valid Java code.  No line break,
-# so that the input and output line numbers will match.
-print "class trans_wms { void tr(String s){} void f() {";
-
-my @lines;
-if($ARGV[0] && $ARGV[0] =~ /^http:\/\//)
-{
-  my $content = get($ARGV[0]);
-  die "Couldn't get $ARGV[0]" unless defined $content;
-  @lines = split("\r?\n", $content);
-}
-else
-{
-  @lines = <>;
-}
-
-for my $line (@lines)
-{
-  $line =~ s/\r//g;
-  chomp($line);
-  print "tr(\"\"); ";
-  if($line =~ /<name>(.*)<\/name>/)
-  {
-    my $val = $1;
-    $val =~ s/&amp;/&/g;
-    print "tr(\"$val\"); /* $line */\n";
-  }
-  elsif($line =~ /^[ \t]*$/)
-  {
-    print "\n";
-  }
-  elsif($line =~ /<entry>/) # required or the gettext info texts get too large
-  {
-    print "public newEntry() {};\n";
-  }
-  else
-  {
-    print "/* $line */\n";
-  }
-}
-
-print "}}\n";