Index: applications/editors/josm/plugins/mapillary/.settings/Build JOSM-Mapillary.launch
===================================================================
--- applications/editors/josm/plugins/mapillary/.settings/Build JOSM-Mapillary.launch	(revision 31798)
+++ applications/editors/josm/plugins/mapillary/.settings/Build JOSM-Mapillary.launch	(revision 31798)
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<launchConfiguration type="org.eclipse.buildship.core.launch.runconfiguration">
+  <listAttribute key="arguments"/>
+  <stringAttribute key="bad_container_name" value="/josm-mapillary-plugin/.settingd"/>
+  <stringAttribute key="gradle_distribution" value="GRADLE_DISTRIBUTION(WRAPPER)"/>
+  <listAttribute key="jvm_arguments"/>
+  <stringAttribute key="org.eclipse.debug.ui.ATTR_CONSOLE_ENCODING" value="UTF-8"/>
+  <listAttribute key="org.eclipse.debug.ui.favoriteGroups">
+    <listEntry value="org.eclipse.debug.ui.launchGroup.run"/>
+  </listAttribute>
+  <booleanAttribute key="show_console_view" value="true"/>
+  <booleanAttribute key="show_execution_view" value="false"/>
+  <listAttribute key="tasks">
+    <listEntry value="build"/>
+  </listAttribute>
+  <stringAttribute key="working_dir" value="${workspace_loc:/JOSM-Mapillary}"/>
+</launchConfiguration>
Index: applications/editors/josm/plugins/mapillary/.settings/Launch JOSM with JOSM-Mapillary loaded.launch
===================================================================
--- applications/editors/josm/plugins/mapillary/.settings/Launch JOSM with JOSM-Mapillary loaded.launch	(revision 31798)
+++ applications/editors/josm/plugins/mapillary/.settings/Launch JOSM with JOSM-Mapillary loaded.launch	(revision 31798)
@@ -0,0 +1,16 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<launchConfiguration type="org.eclipse.buildship.core.launch.runconfiguration">
+  <listAttribute key="arguments"/>
+  <stringAttribute key="gradle_distribution" value="GRADLE_DISTRIBUTION(WRAPPER)"/>
+  <listAttribute key="jvm_arguments"/>
+  <stringAttribute key="org.eclipse.debug.ui.ATTR_CONSOLE_ENCODING" value="UTF-8"/>
+  <listAttribute key="org.eclipse.debug.ui.favoriteGroups">
+    <listEntry value="org.eclipse.debug.ui.launchGroup.run"/>
+  </listAttribute>
+  <booleanAttribute key="show_console_view" value="true"/>
+  <booleanAttribute key="show_execution_view" value="true"/>
+  <listAttribute key="tasks">
+    <listEntry value="runJosm"/>
+  </listAttribute>
+  <stringAttribute key="working_dir" value="${workspace_loc:/JOSM-Mapillary}"/>
+</launchConfiguration>
Index: applications/editors/josm/plugins/mapillary/.settings/Test JOSM-Mapillary.launch
===================================================================
--- applications/editors/josm/plugins/mapillary/.settings/Test JOSM-Mapillary.launch	(revision 31798)
+++ applications/editors/josm/plugins/mapillary/.settings/Test JOSM-Mapillary.launch	(revision 31798)
@@ -0,0 +1,24 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<launchConfiguration type="org.eclipse.jdt.junit.launchconfig">
+  <listAttribute key="com.mountainminds.eclemma.core.SCOPE_IDS">
+    <listEntry value="=JOSM-Mapillary/src"/>
+  </listAttribute>
+  <listAttribute key="org.eclipse.debug.core.MAPPED_RESOURCE_PATHS">
+    <listEntry value="/JOSM-Mapillary"/>
+  </listAttribute>
+  <listAttribute key="org.eclipse.debug.core.MAPPED_RESOURCE_TYPES">
+    <listEntry value="4"/>
+  </listAttribute>
+  <stringAttribute key="org.eclipse.debug.ui.ATTR_CONSOLE_ENCODING" value="UTF-8"/>
+  <listAttribute key="org.eclipse.debug.ui.favoriteGroups">
+    <listEntry value="com.mountainminds.eclemma.ui.launchGroup.coverage"/>
+    <listEntry value="org.eclipse.debug.ui.launchGroup.run"/>
+  </listAttribute>
+  <stringAttribute key="org.eclipse.jdt.junit.CONTAINER" value="=JOSM-Mapillary"/>
+  <booleanAttribute key="org.eclipse.jdt.junit.KEEPRUNNING_ATTR" value="false"/>
+  <stringAttribute key="org.eclipse.jdt.junit.TESTNAME" value=""/>
+  <stringAttribute key="org.eclipse.jdt.junit.TEST_KIND" value="org.eclipse.jdt.junit.loader.junit4"/>
+  <booleanAttribute key="org.eclipse.jdt.launching.ATTR_USE_START_ON_FIRST_THREAD" value="true"/>
+  <stringAttribute key="org.eclipse.jdt.launching.MAIN_TYPE" value=""/>
+  <stringAttribute key="org.eclipse.jdt.launching.PROJECT_ATTR" value="JOSM-Mapillary"/>
+</launchConfiguration>