Index: applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/JosmSelectionListModelTest.groovy
===================================================================
--- applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/JosmSelectionListModelTest.groovy	(revision 32361)
+++ applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/JosmSelectionListModelTest.groovy	(revision 32363)
@@ -4,5 +4,7 @@
 
 import org.openstreetmap.josm.gui.MainApplication;
-import org.openstreetmap.josm.gui.layer.OsmDataLayer;
+import org.openstreetmap.josm.gui.layer.OsmDataLayer
+import org.openstreetmap.josm.testutils.JOSMTestRules;
+
 import javax.swing.DefaultListSelectionModel;
 import org.openstreetmap.josm.data.osm.*;
@@ -21,11 +23,9 @@
  */
 class JosmSelectionListModelTest extends GroovyTestCase {
-	final shouldFail = new GroovyTestCase().&shouldFail
-	
-	@Before
-	public void setUp() {
-		JOSMFixture.createUnitTestFixture().init()
-	}
-	
+    final shouldFail = new GroovyTestCase().&shouldFail
+
+    @Rule
+    public JOSMTestRules rules = new JOSMTestRules().preferences();
+
 	@Test
 	public void test_Constructor(){
Index: applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/TurnRestrictionEditorModelUnitTest.groovy
===================================================================
--- applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/TurnRestrictionEditorModelUnitTest.groovy	(revision 32361)
+++ applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/TurnRestrictionEditorModelUnitTest.groovy	(revision 32363)
@@ -14,6 +14,6 @@
 import org.openstreetmap.josm.data.coor.*
 import org.openstreetmap.josm.fixtures.JOSMFixture;
-import org.openstreetmap.josm.gui.layer.OsmDataLayer;
-
+import org.openstreetmap.josm.gui.layer.OsmDataLayer
+import org.openstreetmap.josm.testutils.JOSMTestRules;
 import org.openstreetmap.josm.JOSMFixture;
 
@@ -24,6 +24,9 @@
 class TurnRestrictionEditorModelUnitTest extends GroovyTestCase{
 
-	final shouldFail = new GroovyTestCase().&shouldFail
-	
+    final shouldFail = new GroovyTestCase().&shouldFail
+
+    @Rule
+    public JOSMTestRules rules = new JOSMTestRules().preferences();
+
 	def navigationControlerMock = [
        gotoBasicEditor:{}, 
@@ -96,12 +99,8 @@
 	@Before
 	public void setUp() {
-		JOSMFixture.createUnitTestFixture().init()
-			
 		ds = new DataSet()
 		layer = new OsmDataLayer(ds, "test", null)		
 		model = new TurnRestrictionEditorModel(layer, navigationControlerMock);
 	}
-	
-	
 	
 	/**
Index: applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/TurnRestrictionLegEditorUnitTest.groovy
===================================================================
--- applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/TurnRestrictionLegEditorUnitTest.groovy	(revision 32361)
+++ applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/TurnRestrictionLegEditorUnitTest.groovy	(revision 32363)
@@ -4,6 +4,6 @@
 
 import org.openstreetmap.josm.data.osm.DataSet;
-import org.openstreetmap.josm.gui.layer.OsmDataLayer;
-
+import org.openstreetmap.josm.gui.layer.OsmDataLayer
+import org.openstreetmap.josm.testutils.JOSMTestRules;
 import org.openstreetmap.josm.JOSMFixture;
 
@@ -15,6 +15,9 @@
  */
 class TurnRestrictionLegEditorUnitTest extends GroovyTestCase {
-	final shouldFail = new GroovyTestCase().&shouldFail
-	
+    final shouldFail = new GroovyTestCase().&shouldFail
+
+    @Rule
+    public JOSMTestRules rules = new JOSMTestRules().preferences();
+
 	def navigationControlerMock = [
        gotoBasicEditor:{}, 
@@ -28,6 +31,4 @@
 	@Before
 	public void setUp() {
-		JOSMFixture.createUnitTestFixture().init()
-		
 		ds = new DataSet()
 		layer = new OsmDataLayer(ds, "test", null)		
Index: applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/TurnRestrictionTypeRendererTest.groovy
===================================================================
--- applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/TurnRestrictionTypeRendererTest.groovy	(revision 32361)
+++ applications/editors/josm/plugins/turnrestrictions/test/unit/org/openstreetmap/josm/plugins/turnrestrictions/editor/TurnRestrictionTypeRendererTest.groovy	(revision 32363)
@@ -7,13 +7,12 @@
 
 import java.awt.Component
-import org.openstreetmap.josm.JOSMFixture;
+import org.openstreetmap.josm.JOSMFixture
+import org.openstreetmap.josm.testutils.JOSMTestRules;;
 
 class TurnRestrictionTypeRendererTest extends GroovyTestCase{
 
-	@Before
-	public void setUp() {
-		JOSMFixture.createUnitTestFixture().init()			
-	}
-	
+    @Rule
+    public JOSMTestRules rules = new JOSMTestRules().preferences();
+
 	@Test
 	public void test_Constructor() {